import React from 'react';
import { storiesOf } from '@storybook/react';
import { withInfo } from '@storybook/addon-info';
import { withNotes } from '@storybook/addon-notes';
import BrandWallSlide from '../BrandWallSlide';
import defaultNotes from './BrandWallSlide.md';
import passSourceNotes from './BrandWallSlide_with_profiles.md';
import customWidthNotes from './BrandWallSlide_custom_width.md';
import AdProfiles from './AdProfiles';

const stories = storiesOf('BrandWallSlide', module);

stories.add(
  'Default',
  withInfo()(
    withNotes(defaultNotes)(() => {
      return (
        <div style={{ width: '334px' }}>
          <BrandWallSlide />
        </div>
      );
    })
  )
);

stories.add(
  'Custom ad banner width',
  withInfo()(
    withNotes(customWidthNotes)(() => {
      return (
        <div style={{ width: '368px' }}>
          <BrandWallSlide adWidth={368} />
        </div>
      );
    })
  )
);

stories.add(
  'With Profile Sources',
  withInfo()(
    withNotes(passSourceNotes)(() => {
      return (
        <div style={{ width: '100%' }}>
          <BrandWallSlide adWidth={100} adWidthUnit="vw" adProfileSource={AdProfiles} />
        </div>
      );
    })
  )
);

// storiesOf('BrandWallSlide', module).add('Default', withInfo()(withNotes(defaultNotes)(() => <BrandWallSlide />)));
